local pFrame, pFrameTitle, pFrameTitleText
local HealBot_Plugin_luVars={}
local HealBot_Plugin_Config={}
local HealBot_Plugin={}
local LSM = HealBot_Libs_LSM()
HealBot_Plugin_luVars["frameInit"]=false
local pId="QuickSet"
local pBars={}

local function HealBot_Plugin_SetPoint(new)
	local fTop=HealBot_Plugin_Config.frameY[HealBot_Plugin.Profile]
	local fLeft=HealBot_Plugin_Config.frameX[HealBot_Plugin.Profile]
	if new then
		fTop=pFrame:GetTop() or HealBot_Plugin_Config.frameY[HealBot_Plugin.Profile]
		fLeft=pFrame:GetLeft() or HealBot_Plugin_Config.frameX[HealBot_Plugin.Profile]
	end
	if fTop>GetScreenHeight() then fTop=GetScreenHeight(); end
	if fTop<pFrame:GetHeight() then fTop=pFrame:GetHeight(); end
	if fLeft>GetScreenWidth()-pFrame:GetWidth() then fLeft=GetScreenWidth()-pFrame:GetWidth() end
	if fLeft<0 then fLeft=0 end
	HealBot_Plugin_Config.frameY[HealBot_Plugin.Profile] = fTop
	HealBot_Plugin_Config.frameX[HealBot_Plugin.Profile] = fLeft
	pFrame:ClearAllPoints()
	pFrame:SetPoint("TOPLEFT","UIParent","BOTTOMLEFT",
	                     HealBot_Plugin_Config.frameX[HealBot_Plugin.Profile],
						 HealBot_Plugin_Config.frameY[HealBot_Plugin.Profile]);
end

local function HealBot_Plugin_UpdateTitle()
	pFrameTitleText:SetFont(LSM:Fetch('font',HealBot_Plugin_Config.font[HealBot_Plugin.Profile]),
                                             HealBot_Plugin_Config.fontsize[HealBot_Plugin.Profile])
	pFrameTitleText:SetText(HealBot_Plugin_Config.titletext[HealBot_Plugin.Profile])
end

local function HealBot_Plugin_SetTitle()
    pFrameTitle=CreateFrame("StatusBar", "HealBot_"..pId.."_FrameTitle", pFrame)
	pFrameTitle:SetPoint("TOPLEFT",pFrame, 2, -2)
    pFrameTitle:SetHeight(19)
    pFrameTitle:SetWidth(HealBot_Plugin_Config.frameWidth[HealBot_Plugin.Profile]-4)
	pFrameTitle:SetStatusBarTexture("Interface\\AddOns\\HealBot\\Images\\bar8.tga")
	pFrameTitleText=pFrameTitle:CreateFontString("HealBot_"..pId.."_FrameTitleText", "ARTWORK", "GameFontNormal")
	pFrameTitleText:SetPoint("TOP", pFrameTitle, "TOP", 0, -4)
	HealBot_Plugin_UpdateTitle()
	HealBot_Plugin_QuickSet_SetTitleCol()
end

local function HealBot_Plugin_OnMouseDown(self, button)
    if not HealBot_Plugin_Config.frameLocked[HealBot_Plugin.Profile] then
		if button=="LeftButton" and not pFrame.isMoving then
			pFrame:StartMoving();
			pFrame.isMoving = true;
		end
    end
end

local function HealBot_Plugin_OnMouseUp(self, button)
    if button=="LeftButton" and pFrame.isMoving then
		pFrame:StopMovingOrSizing();
		pFrame.isMoving = false;
		local fTop=pFrame:GetTop()
		local fLeft=pFrame:GetLeft()
		if (fTop>GetScreenHeight()) or 
		   (fTop<pFrame:GetHeight()) or 
		   (fLeft>GetScreenWidth()-pFrame:GetWidth()) or 
		   (fLeft<0) then 
			HealBot_Plugin_SetPoint(true)
		else
			HealBot_Plugin_Config.frameY[HealBot_Plugin.Profile] = fTop
			HealBot_Plugin_Config.frameX[HealBot_Plugin.Profile] = fLeft
		end
    elseif button=="RightButton" and not HealBot_Data["UILOCK"] and HealBot_Globals.RightButtonOptions then
        HealBot_Action_OptionsButton_OnClick();
    end
end

local function HealBot_Plugin_UpdateUsedMedia(mediatype, key)
    if mediatype == "statusbar" then
		for f=1,40 do
			if pBars[f] then
				pBars[f]:SetStatusBarTexture(LSM:Fetch('statusbar',HealBot_Plugin_Config.texture[HealBot_Plugin.Profile]))
			else
				break
			end
		end
    elseif mediatype == "font" then
		for f=1,40 do
			if pBars[f] then
				pBars[f].TextL:SetFont(LSM:Fetch('font',HealBot_Plugin_Config.font[HealBot_Plugin.Profile]),
											HealBot_Plugin_Config.fontsize[HealBot_Plugin.Profile],
											HealBot_Font_Outline[HealBot_Plugin_Config.txtoutline[HealBot_Plugin.Profile]])
				pBars[f].TextR:SetFont(LSM:Fetch('font',HealBot_Plugin_Config.font[HealBot_Plugin.Profile]),
											HealBot_Plugin_Config.fontsize[HealBot_Plugin.Profile],
											HealBot_Font_Outline[HealBot_Plugin_Config.txtoutline[HealBot_Plugin.Profile]])
			else
				break
			end
		end
    end
end

function HealBot_Plugin_QuickSet_Init()
	if not HealBot_Plugin_luVars["pluginInit"] then
		table.foreach(HealBot_Plugin_QuickSetDefaults, function (key,val)
			if HealBot_Plugin_QuickSet[key]==nil then
				HealBot_Plugin_QuickSet[key] = val;
			end
		end);
		table.foreach(HealBot_Plugin_QuickSet_ConfigDefaults, function (key,val)
			if HealBot_Plugin_QuickSet_Config[key]==nil then
				HealBot_Plugin_QuickSet_Config[key] = val;
			end
		end);
		HealBot_Plugin_Config=HealBot_Plugin_QuickSet_Config
		HealBot_Plugin=HealBot_Plugin_QuickSet
		if HealBot_Plugin.Profile~="Global" then HealBot_Plugin.Profile=UnitName("player") end
		
		pFrame=CreateFrame("Frame", "HealBot_QuickSet_Frame", UIParent, BackdropTemplateMixin and "BackdropTemplate")
		pFrame:SetBackdrop({
			bgFile = "Interface\\Addons\\HealBot\\Images\\WhiteLine",
			edgeFile = "Interface\\Addons\\HealBot\\Images\\border",
			tile = true,
			tileSize = 8,
			edgeSize = 8,
			insets = { left = 3, right = 3, top = 3, bottom = 3, },
		})
		pFrame:SetMovable(true)
		pFrame:EnableMouse(true)
		pFrame:SetScript("OnMouseDown", function(self, button) HealBot_Plugin_OnMouseDown(self, button) end)
		pFrame:SetScript("OnMouseUp", function(self, button) HealBot_Plugin_OnMouseUp(self, button) end)
		
		pFrame:SetWidth(HealBot_Plugin_Config.frameWidth[HealBot_Plugin.Profile])
		HideUIPanel(pFrame)
		if HealBot_Plugin_Config.frameX[HealBot_Plugin.Profile]==-1 then
			HealBot_Plugin_Config.frameX[HealBot_Plugin.Profile]=10
		end
		if HealBot_Plugin_Config.frameY[HealBot_Plugin.Profile]==-1 then
			HealBot_Plugin_Config.frameY[HealBot_Plugin.Profile]=HealBot_Comm_round(GetScreenHeight()/2,0)
		end
        LSM.RegisterCallback(HEALBOT_HEALBOT..pId, "LibSharedMedia_SetGlobal", function(mediatype, key) HealBot_Plugin_UpdateUsedMedia(mediatype, key) end)
		HealBot_Plugin_SetTitle()
		HealBot_Plugin_luVars["pluginInit"]=true
	end
	HealBot_Plugin_QuickSet_UpdateAll()
	HealBot_setOptions_Timer(3700)
end

local function HealBot_Plugin_UpdateFrameHeight()
	local h=22+((HealBot_Plugin_Config.height[HealBot_Plugin.Profile]+HealBot_Plugin_Config.rowspace[HealBot_Plugin.Profile])*HealBot_Plugin_Config.maxBars[HealBot_Plugin.Profile])
	pFrame:SetHeight(h)
end

local function HealBot_Plugin_QuickSet_Update()
	HealBot_Plugin_UpdateFrameHeight()
end

function HealBot_Plugin_QuickSet_UnitUpdate(button)

	HealBot_Plugin_QuickSet_Update()
end

function HealBot_Plugin_QuickSet_CallUpdateAll()
	if HealBot_Plugin_luVars["testMode"] then
		HealBot_Plugin_QuickSet_TestMode(true)
	else
		HealBot_Plugin_QuickSet_UpdateAll()
	end
end

local function HealBot_Plugin_UpdateBarWidth(bar)
	bar:SetWidth(HealBot_Plugin_Config.frameWidth[HealBot_Plugin.Profile]-4)
end

local function HealBot_Plugin_UpdateBarSetPoint(bar)
	if bar.id==1 then
		bar:SetPoint("TOP", pFrameTitle, "BOTTOM", 0, 0-HealBot_Plugin_Config.rowspace[HealBot_Plugin.Profile])
	else
		bar:SetPoint("TOP", pBars[bar.id-1], "BOTTOM", 0, 0-HealBot_Plugin_Config.rowspace[HealBot_Plugin.Profile])
	end
end

local function HealBot_Plugin_UpdateBarHeight(bar)
	bar:SetHeight(HealBot_Plugin_Config.height[HealBot_Plugin.Profile])
end

local function HealBot_Plugin_UpdateBarText(bar)
	bar.TextL:SetFont(LSM:Fetch('font',HealBot_Plugin_Config.font[HealBot_Plugin.Profile]),
                                HealBot_Plugin_Config.fontsize[HealBot_Plugin.Profile],
                                HealBot_Font_Outline[HealBot_Plugin_Config.txtoutline[HealBot_Plugin.Profile]])
	bar.TextR:SetFont(LSM:Fetch('font',HealBot_Plugin_Config.font[HealBot_Plugin.Profile]),
                                HealBot_Plugin_Config.fontsize[HealBot_Plugin.Profile],
                                HealBot_Font_Outline[HealBot_Plugin_Config.txtoutline[HealBot_Plugin.Profile]])
end

local function HealBot_Plugin_UpdateBarTexture(bar)
	bar:SetStatusBarTexture(LSM:Fetch('statusbar',HealBot_Plugin_Config.texture[HealBot_Plugin.Profile]))
end

function HealBot_Plugin_QuickSet_UpdateAll()
	for f=1,HealBot_Plugin_Config.maxBars[HealBot_Plugin.Profile] do
		if not pBars[f] then
			pBars[f]=CreateFrame("StatusBar", "pBar_"..pId..f, pFrame) 
			pBars[f].id=f
			pBars[f].unit="nil"
			pBars[f]:SetMinMaxValues(0,100)
			pBars[f]:SetValue(0)
			pBars[f]:Hide()
			pBars[f].TextL=pBars[f]:CreateFontString()
			pBars[f].TextL:SetPoint("LEFT",0,-1)
			pBars[f].TextR=pBars[f]:CreateFontString()
			pBars[f].TextR:SetPoint("RIGHT",0,-1)
			HealBot_Plugin_UpdateBarTexture(pBars[f])
			HealBot_Plugin_UpdateBarText(pBars[f])
			HealBot_Plugin_UpdateBarHeight(pBars[f])
			HealBot_Plugin_UpdateBarWidth(pBars[f])
			HealBot_Plugin_UpdateBarSetPoint(pBars[f])
		end
	end
	HealBot_Plugin_SetPoint()
	HealBot_Plugin_QuickSet_SetFrameCols()
	HealBot_Plugin_QuickSet_SetTitleCol()
	HealBot_Plugin_UpdateTitle()
	HealBot_Plugin_QuickSet_Update()
end

function HealBot_Plugin_QuickSet_UpdateTitle()
	HealBot_Plugin_UpdateTitle()
end

function HealBot_Plugin_QuickSet_ShowPanel()
	ShowUIPanel(pFrame)
end

function HealBot_Plugin_QuickSet_HidePanel()
	HideUIPanel(pFrame)
end

function HealBot_Plugin_QuickSet_TogglePanel(inCombat)
	if HealBot_Plugin_Config.OnlyShowOutOfCombat[HealBot_Plugin.Profile] then
		if inCombat then
			HideUIPanel(pFrame)
		else
			ShowUIPanel(pFrame)
		end	
	else
		ShowUIPanel(pFrame)	
	end
end

function HealBot_Plugin_QuickSet_Shutdown()
	HideUIPanel(pFrame)
end

function HealBot_Plugin_QuickSet_UpdateBarRowSpacer()
	for f=1,40 do
		if pBars[f] then
			HealBot_Plugin_UpdateBarSetPoint(pBars[f])
		else
			break
		end
	end
	HealBot_Plugin_UpdateFrameHeight()
end

function HealBot_Plugin_QuickSet_UpdateHeight()
	for f=1,40 do
		if pBars[f] then
			HealBot_Plugin_UpdateBarHeight(pBars[f])
		else
			break
		end
	end
	HealBot_Plugin_UpdateFrameHeight()
end

function HealBot_Plugin_QuickSet_UpdateText()
	for f=1,40 do
		if pBars[f] then
			HealBot_Plugin_UpdateBarText(pBars[f])
		else
			break
		end
	end
end

function HealBot_Plugin_QuickSet_UpdateTexture()
	for f=1,40 do
		if pBars[f] then
			HealBot_Plugin_UpdateBarTexture(pBars[f])
		else
			break
		end
	end
end

function HealBot_Plugin_QuickSet_FrameWidth()
	pFrame:SetWidth(HealBot_Plugin_Config.frameWidth[HealBot_Plugin.Profile])
	pFrameTitle:SetWidth(HealBot_Plugin_Config.frameWidth[HealBot_Plugin.Profile]-4)
	for f=1,40 do
		if pBars[f] then
			HealBot_Plugin_UpdateBarWidth(pBars[f])
		else
			break
		end
	end
end

function HealBot_Plugin_QuickSet_SetFrameCols()
	pFrame:SetBackdropColor(HealBot_Plugin_Config.frameR[HealBot_Plugin.Profile],
	                             HealBot_Plugin_Config.frameG[HealBot_Plugin.Profile],
								 HealBot_Plugin_Config.frameB[HealBot_Plugin.Profile],
								 HealBot_Plugin_Config.frameA[HealBot_Plugin.Profile])
	pFrame:SetBackdropBorderColor(HealBot_Plugin_Config.borderR[HealBot_Plugin.Profile],
	                                   HealBot_Plugin_Config.borderG[HealBot_Plugin.Profile],
								       HealBot_Plugin_Config.borderB[HealBot_Plugin.Profile],
								       HealBot_Plugin_Config.borderA[HealBot_Plugin.Profile])
end

function HealBot_Plugin_QuickSet_SetTitleCol()
	pFrameTitle:SetStatusBarColor(HealBot_Plugin_Config.titlebackR[HealBot_Plugin.Profile],
	                              HealBot_Plugin_Config.titlebackG[HealBot_Plugin.Profile],
								  HealBot_Plugin_Config.titlebackB[HealBot_Plugin.Profile],
								  HealBot_Plugin_Config.titlebackA[HealBot_Plugin.Profile])
	pFrameTitleText:SetTextColor(HealBot_Plugin_Config.titletextR[HealBot_Plugin.Profile], 
	                             HealBot_Plugin_Config.titletextG[HealBot_Plugin.Profile], 
								 HealBot_Plugin_Config.titletextB[HealBot_Plugin.Profile], 
								 HealBot_Plugin_Config.titletextA[HealBot_Plugin.Profile])
end

function HealBot_Plugin_QuickSet_TestMode(enable)

end
